diff -N -r -u mldonkey-src/src/daemon/driver/driverCommands.ml mldonkey/src/daemon/driver/driverCommands.ml
--- mldonkey/src/daemon/driver/driverCommands.ml	Sun Jul 17 23:43:43 2005
+++ mldonkey/src/daemon/driver/driverCommands.ml	Mon Jul 18 01:03:56 2005
@@ -605,13 +605,13 @@
 \\<tr\\>\\<td\\>
 \\<table cellspacing=0 cellpadding=0  width=100%%\\>\\<tr\\>
 \\<td class=downloaded width=100%%\\>\\</td\\>
-\\<td nowrap class=\\\"fbig pr\\\"\\>\\<a onclick=\\\"javascript: {
-                   var getdir = prompt('Input: <user> <pass>','user pass')
-                   var reg = new RegExp (' ', 'gi') ;
-                   var outstr = getdir.replace(reg, '+');
-                   parent.fstatus.location.href='submit?q=add_user+' + outstr;
-                   setTimeout('window.location.reload()',1000);
-                    }\\\"\\>Add User\\</a\\>
+\\<td nowrap class=\\\"fbig pr\\\"\\>\\<a onclick=\\\'javascript: {
+                   var getdir = prompt(\\\"Input: <user> <pass>\\\",\\\"user pass\\\")
+                   var reg = new RegExp (\\\" \\\", \\\"gi\\\") ;
+                   var outstr = getdir.replace(reg, \\\"+\\\");
+                   parent.fstatus.location.href=\\\"submit?q=add_user+\\\" + outstr;
+                   setTimeout(\\\"window.location.reload()\\\",1000);
+                    }\\\'\\>Add User\\</a\\>
 \\</td\\>
 \\</tr\\>\\</table\\>
 \\</td\\>\\</tr\\>
@@ -633,7 +633,7 @@
         onMouseOut=\\\"mOut(this);\\\"
         onClick=\\\'javascript:{
         parent.fstatus.location.href=\\\"submit?q=remove_user+\\\\\\\"%s\\\\\\\"\\\";
-        setTimeout(\\\"window.location.reload()\\\",1000);}'
+        setTimeout(\\\"window.location.reload()\\\",1000);}\\\'
         class=\\\"srb\\\"\\>Remove\\</td\\>" user
 		else Printf.bprintf buf "
         \\<td title=\\\"\\\"
@@ -843,16 +843,16 @@
 \\<td class=downloaded width=100%%\\>\\</td\\>
 \\<td nowrap class=fbig\\>\\<a onclick=\\\"javascript:window.location.reload()\\\"\\>Refresh\\</a\\> \\</td\\>
 \\<td nowrap class=fbig\\>\\<a onclick=\\\"javascript:
-                  { parent.fstatus.location.href='submit?q=friend_remove+all';
-                    setTimeout('window.location.reload()',1000);
+                  { parent.fstatus.location.href=\\\'submit?q=friend_remove+all\\\';
+                    setTimeout(\\\'window.location.reload()\\\',1000);
                     }\\\"\\>Remove All\\</a\\>
 \\</td\\>
 \\<td nowrap class=\\\"fbig pr\\\"\\>\\<a onclick=\\\"javascript: {
-                   var getip = prompt('Friend IP [port] ie: 192.168.0.1 4662','192.168.0.1 4662')
-                   var reg = new RegExp (' ', 'gi') ;
-                   var outstr = getip.replace(reg, '+');
-                   parent.fstatus.location.href='submit?q=afr+' + outstr;
-                    setTimeout('window.location.reload()',1000);
+                   var getip = prompt(\\\'Friend IP [port] ie: 192.168.0.1 4662\\\',\\\'192.168.0.1 4662\\\')
+                   var reg = new RegExp (\\\' \\\', \\\'gi\\\') ;
+                   var outstr = getip.replace(reg, \\\'+\\\');
+                   parent.fstatus.location.href=\\\'submit?q=afr+\\\' + outstr;
+                    setTimeout(\\\'window.location.reload()\\\',1000);
                     }\\\"\\>Add by IP\\</a\\>
 \\</td\\>
 \\</tr\\>\\</table\\>
@@ -1820,13 +1820,13 @@
 \\<tr\\>\\<td\\>
 \\<table cellspacing=0 cellpadding=0  width=100%%\\>\\<tr\\>
 \\<td class=downloaded width=100%%\\>\\</td\\>
-\\<td nowrap class=\\\"fbig pr\\\"\\>\\<a onclick=\\\"javascript: {
-                   var getdir = prompt('Input: <priority#> <directory> (surround dir with quotes if necessary)','0 /home/mldonkey/share')
-                   var reg = new RegExp (' ', 'gi') ;
-                   var outstr = getdir.replace(reg, '+');
-                   parent.fstatus.location.href='submit?q=share+' + outstr;
-                   setTimeout('window.location.reload()',1000);
-                    }\\\"\\>Add Share\\</a\\>
+\\<td nowrap class=\\\"fbig pr\\\"\\>\\<a onclick=\\\'javascript: {
+                   var getdir = prompt(\\\"Input: <priority#> <directory> (surround dir with quotes if necessary)\\\",\\\"0 /home/mldonkey/share\\\")
+                   var reg = new RegExp (\\\" \\\", \\\"gi\\\") ;
+                   var outstr = getdir.replace(reg, \\\"+\\\");
+                   parent.fstatus.location.href=\\\"submit?q=share+\\\" + outstr;
+                   setTimeout(\\\"window.location.reload()\\\",1000);
+                    }\\\'\\>Add Share\\</a\\>
 \\</td\\>
 \\</tr\\>\\</table\\>
 \\</td\\>\\</tr\\>
@@ -1853,7 +1853,7 @@
         onMouseOut=\\\"mOut(this);\\\"
         onClick=\\\'javascript:{
         parent.fstatus.location.href=\\\"submit?q=unshare+\\\\\\\"%s\\\\\\\"\\\"
-        setTimeout(\\\"window.location.reload()\\\",1000);}'
+        setTimeout(\\\"window.location.reload()\\\",1000);}\\\'
         class=\\\"srb\\\"\\>Unshare\\</td\\>
         \\<td class=\\\"sr ar\\\"\\>%d\\</td\\>
         \\<td class=\\\"sr\\\"\\>%s\\</td\\>